// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

namespace Microsoft.Samples.Discovery.LegacyChat
{
    using System;
    using System.ServiceModel;
    using DiscoveryProxy.Contracts;
    using Microsoft.Samples.Discovery.Contracts;
    
    public class PeerChat
    {
        public PeerChat(string fromName, string fromAddress, ChatUser toUser)
        {
            this.fromName = fromName;
            this.fromUri = fromAddress;
            this.user = toUser;
        }

        private string fromName;
        private string fromUri;
        private ChatUser user;

        public ChatUser User
        {
            get { return this.user; }
        }

        private ISimpleChatService Connect()
        {
            BasicHttpBinding binding = new BasicHttpBinding();
            EndpointAddress address = new EndpointAddress(this.User.Address);

            return ChannelFactory<ISimpleChatService>.CreateChannel(binding, address);
        }

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance", "CA1800:DoNotCastUnnecessarily", Justification = "Demo code")]
        public void Chat(string message)
        {
            ChatMessage chatMessage = new ChatMessage(
                this.fromName,
                message,
                new Uri(this.fromUri));

            ISimpleChatService chatProxy = this.Connect();
            try
            {
                chatProxy.ProcessSimpleMessage(chatMessage);
                ((ICommunicationObject)chatProxy).Close();
            }
            catch (Exception)
            {
                ((ICommunicationObject)chatProxy).Abort();
                throw;
            }
        }
    }
}