// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

namespace DiscoveryProxy.Contracts
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Runtime.Serialization;
    using System.ServiceModel;
    using System.Text;

    [ServiceContract(ConfigurationName = "ILegacyChat", Name = "LegacyChat", Namespace = "http://sample.microsoft.com/wcf4")]
    public interface ILegacyChatProxy
    {
        [OperationContract(IsOneWay = true)]
        void Register(Uri chatUri, string name);

        [OperationContract(IsOneWay = true)]
        void Unregister(Uri chatUri);

        [OperationContract]
        List<ChatUser> GetUsers();
    }

    [DataContract]
    public class ChatUser
    {
        [DataMember]
        public string Username { get; set; }
        [DataMember]
        public string Address { get; set; }
    }
}