' ----------------------------------------------------------------------------------
' Microsoft Developer & Platform Evangelism
' 
' Copyright (c) Microsoft Corporation. All rights reserved.
' 
' THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
' EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
' OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ----------------------------------------------------------------------------------
' The example companies, organizations, products, domain names,
' e-mail addresses, logos, people, places, and events depicted
' herein are fictitious.  No association with any real company,
' organization, product, domain name, email address, logo, person,
' places, or events is intended or should be inferred.
' ----------------------------------------------------------------------------------

Imports System.Runtime.Serialization
Imports System.ServiceModel
Imports System.Text

Namespace Contracts
    <ServiceContract(ConfigurationName:="ILegacyChat", Name:="LegacyChat", Namespace:="http://sample.microsoft.com/wcf4")>
    Public Interface ILegacyChatProxy
        <OperationContract(IsOneWay:=True)>
        Sub Register(ByVal chatUri As Uri, ByVal name As String)

        <OperationContract(IsOneWay:=True)>
        Sub Unregister(ByVal chatUri As Uri)

        <OperationContract()>
        Function GetUsers() As List(Of ChatUser)
    End Interface

    <DataContract()>
    Public Class ChatUser
        <DataMember()>
        Public Property Username() As String
        <DataMember()>
        Public Property Address() As String
    End Class
End Namespace