' ----------------------------------------------------------------------------------
' Microsoft Developer & Platform Evangelism
' 
' Copyright (c) Microsoft Corporation. All rights reserved.
' 
' THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
' EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
' OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ----------------------------------------------------------------------------------
' The example companies, organizations, products, domain names,
' e-mail addresses, logos, people, places, and events depicted
' herein are fictitious.  No association with any real company,
' organization, product, domain name, email address, logo, person,
' places, or events is intended or should be inferred.
' ----------------------------------------------------------------------------------

Imports System.ServiceModel
Imports DiscoveryProxy.Contracts
Imports Microsoft.Samples.Discovery.Contracts

Namespace Microsoft.Samples.Discovery.LegacyChat

    Public Class PeerChat
        Public Sub New(ByVal fromName As String, ByVal fromAddress As String, ByVal toUser As ChatUser)
            Me.fromName = fromName
            Me.fromUri = fromAddress
            Me.privateUser = toUser
        End Sub

        Private fromName As String
        Private fromUri As String
        Private privateUser As ChatUser

        Public ReadOnly Property User() As ChatUser
            Get
                Return Me.privateUser
            End Get
        End Property

        Private Function Connect() As ISimpleChatService
            Dim binding As New BasicHttpBinding()
            Dim address As New EndpointAddress(Me.User.Address)

            Return ChannelFactory(Of ISimpleChatService).CreateChannel(binding, address)
        End Function

        <System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance", "CA1800:DoNotCastUnnecessarily", Justification := "Demo code")>
        Public Sub Chat(ByVal message As String)
            Dim chatMessage As New ChatMessage(Me.fromName, message, New Uri(Me.fromUri))

            Dim chatProxy = Me.Connect()
            Try
                chatProxy.ProcessSimpleMessage(chatMessage)
                CType(chatProxy, ICommunicationObject).Close()
            Catch e1 As Exception
                CType(chatProxy, ICommunicationObject).Abort()
                Throw
            End Try
        End Sub
    End Class
End Namespace